// AddWorkOffsetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AddWorkOffset.h"
#include "AddWorkOffsetDlg.h"

#include "Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddWorkOffsetDlg dialog

CAddWorkOffsetDlg::CAddWorkOffsetDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CAddWorkOffsetDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CAddWorkOffsetDlg)
    m_inputFileName = _T("");
    m_bG54 = FALSE;
    m_bG55 = FALSE;
    m_bG56 = FALSE;
    m_bG57 = FALSE;
    m_bG58 = FALSE;
    m_bG59 = FALSE;
    m_bGenerateM05 = FALSE;
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAddWorkOffsetDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAddWorkOffsetDlg)
    DDX_Text(pDX, IDC_FILENAME, m_inputFileName);
    DDX_Check(pDX, IDC_G54, m_bG54);
    DDX_Check(pDX, IDC_G55, m_bG55);
    DDX_Check(pDX, IDC_G56, m_bG56);
    DDX_Check(pDX, IDC_G57, m_bG57);
    DDX_Check(pDX, IDC_G58, m_bG58);
    DDX_Check(pDX, IDC_G59, m_bG59);
    DDX_Check(pDX, IDC_GENERATE_M05, m_bGenerateM05);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAddWorkOffsetDlg, CDialog)
    //{{AFX_MSG_MAP(CAddWorkOffsetDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BROWES, OnBrowes)
    ON_BN_CLICKED(IDC_G54, OnG54)
    ON_BN_CLICKED(IDC_G55, OnG55)
    ON_BN_CLICKED(IDC_G56, OnG56)
    ON_BN_CLICKED(IDC_G57, OnG57)
    ON_BN_CLICKED(IDC_G58, OnG58)
    ON_BN_CLICKED(IDC_G59, OnG59)
    ON_BN_CLICKED(IDC_GENERATE_M05, OnGenerateM05)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddWorkOffsetDlg message handlers

BOOL CAddWorkOffsetDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon
    
    // Restore USER settings from the last session.
    m_bG54 = AfxGetApp()->GetProfileInt( "User", "G54", 1 );
    m_bG55 = AfxGetApp()->GetProfileInt( "User", "G55", 0 );
    m_bG56 = AfxGetApp()->GetProfileInt( "User", "G56", 0 );
    m_bG57 = AfxGetApp()->GetProfileInt( "User", "G57", 0 );
    m_bG58 = AfxGetApp()->GetProfileInt( "User", "G58", 0 );
    m_bG59 = AfxGetApp()->GetProfileInt( "User", "G59", 0 );

    m_bGenerateM05 = AfxGetApp()->GetProfileInt( "User", "M05", 1 );

    m_inputFileName = AfxGetApp()->GetProfileString( "User", "PathName" );

    UpdateData( FALSE );
    
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAddWorkOffsetDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAddWorkOffsetDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAddWorkOffsetDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnBrowes() 
//
//  Select the input file name to add workoffsets to
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::OnBrowes() 
{
    // Initialize the dialog.
    CFileDialog fileDlg( TRUE );

    // Get our last settings.
    CString LastPath = AfxGetApp()->GetProfileString( "User", "PathName" );
    CString LastName = AfxGetApp()->GetProfileString( "User", "FileName" );

    char lastName[ 500 ];
    strcpy( lastName, LastName );
    fileDlg.m_ofn.lpstrInitialDir = LastPath;
    fileDlg.m_ofn.lpstrFile = lastName;
    fileDlg.m_ofn.lpstrTitle = "Select a NC/TAP File";
    fileDlg.m_ofn.lpstrFilter = "NC File (*.NC)\0*.nc\0TAP File (*.TAP)\0*.tap\0";

    // Display the File Select Dialoag and Check for a cancel button.
    if( fileDlg.DoModal() == IDCANCEL )
        return;

    // Save the information for next time.
    AfxGetApp()->WriteProfileString( "User", "PathName", fileDlg.GetPathName() );
    AfxGetApp()->WriteProfileString( "User", "FileName", fileDlg.GetFileName() );

    // Get the file parameters.
    m_inputFileName = fileDlg.GetPathName();

    // Update the GUI
    UpdateData( FALSE );
}


void CAddWorkOffsetDlg::addWorkOffset( CStdioFile* outFile, CString& fileBuffer )
{
    // Loop on each offset
    for( int offset = 54; offset <=59 ; offset++ )
    {
        bool process = FALSE;
        switch( offset )
        {
        case 54: if( m_bG54 ) process = TRUE; break;
        case 55: if( m_bG55 ) process = TRUE; break;
        case 56: if( m_bG56 ) process = TRUE; break;
        case 57: if( m_bG57 ) process = TRUE; break;
        case 58: if( m_bG58 ) process = TRUE; break;
        case 59: if( m_bG59 ) process = TRUE; break;
        }

        // Should we process this offset.
        if( process )
        {
            // Add Comment
            CString tempBuffer;
            tempBuffer.Format( "(--- G%d Work Offset Was Added ---)\n", offset );
            outFile->WriteString( tempBuffer );

            // Write out the G Code
            tempBuffer.Format( "G%d\n", offset );
            outFile->WriteString( tempBuffer );

            // Dump the Buffer
            outFile->WriteString( fileBuffer );
        }
    }
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnOK
//
//  Start up the Add Offset Engine
//  
//**************************************************************************************************
void CAddWorkOffsetDlg::OnOK() 
{
    // Make sure we have the current settings
    UpdateData();

    // Make sure we have at least one offset checked.
    if( ! ( m_bG54 || m_bG55 || m_bG56 || m_bG57 || m_bG58 || m_bG59 ))
    {
        MessageBox( "Please select at least one work offset" );
        return;
    }

    // Attempt to Open the File.
    CStdioFile inFile;
    if( ! inFile.Open( m_inputFileName, CFile::modeRead ))
    {
        MessageBox( "Failed to open input file" );
        return;
    }

    // Create the new fileName
    CString outFileName;
    if( m_bG54 )
        outFileName += "G54_";

    if( m_bG55 )
        outFileName += "G55_";

    if( m_bG56 )
        outFileName += "G56_";

    if( m_bG57 )
        outFileName += "G57_";

    if( m_bG58 )
        outFileName += "G58_";

    if( m_bG59 )
        outFileName += "G59_";

    CString outFilePath =  GetDrive( m_inputFileName ) + 
                           //"\" +
                           GetDirectory( m_inputFileName ) +
                           outFileName + 
                           GetFile( m_inputFileName ) + 
                           GetExt( m_inputFileName );

    TRACE( "Output File Name: '%s'\n", outFilePath );

    // Create the output file
    CStdioFile outFile;
    if( ! outFile.Open( outFilePath, CFile::modeWrite | CFile::modeCreate ))
    {
        MessageBox( "Failed to create/open output file" );
        return;
    }

    // Process each line of the file.
    CString lineOfData;
    CString fileBuffer;
    bool firstTool = TRUE;
    while( inFile.ReadString( lineOfData ))
    {
        // TRACE( "'%s'\n", lineOfData );

        // Is this a tool change?
        if( lineOfData.Find( "M06" ) >= 0 )
        {
            // TRACE( "TOOL: '%s'\n", lineOfData );

            // First tool special case
            if( firstTool )
            {
                // Dump the header only once, not for each work offset
                firstTool = FALSE;
                outFile.WriteString( fileBuffer );
                fileBuffer = "";

                // Dump out the tool change line of code
                outFile.WriteString( lineOfData );
                outFile.WriteString( "\n" );
            }
            else
            {
                // Insert the work Offset
                addWorkOffset( &outFile, fileBuffer );

                // Dump out the optional M05 before each tool change
                if( m_bGenerateM05 )
                {
                    outFile.WriteString( "(--- M05 Was Added ---)\n" );
                    outFile.WriteString( "M05\n" );
                }

                // Dump out the tool change line of code
                outFile.WriteString( lineOfData );
                outFile.WriteString( "\n" );

                fileBuffer = "";
            }
        }

        // Eat the M05
        else if( lineOfData.Find( "M05" ) >= 0 )
        {
            
        }

        // Is this the end of the program
        else if( lineOfData.Find( "M30" ) >= 0 )
        {
            // Insert the work Offset
            addWorkOffset( &outFile, fileBuffer );

            // Dump out the M05
            outFile.WriteString( "M05\n" );

            // Dump out the M30
            outFile.WriteString( lineOfData );

            // Stop processing
            MessageBox( "Work Offsets have been successfully added" );
            return;
        }
        else
        {
            // Add to the buffer
            fileBuffer += lineOfData + "\n";
        }
    }
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::Offset
//
//**************************************************************************************************
void CAddWorkOffsetDlg::OnCancel() 
{
    // Close up the dialog
    CDialog::OnCancel();
}

//**************************************************************************************************
//
//  CAddWorkOffsetDlg::OnG54 - OnG59
//
//  Save off the settings for next time...
//
//**************************************************************************************************
void CAddWorkOffsetDlg::OnG54() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G54", m_bG54 );
}

void CAddWorkOffsetDlg::OnG55() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G55", m_bG55 );
}

void CAddWorkOffsetDlg::OnG56() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G56", m_bG56 );
}

void CAddWorkOffsetDlg::OnG57() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G57", m_bG57 );
}

void CAddWorkOffsetDlg::OnG58() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G58", m_bG58 );
}

void CAddWorkOffsetDlg::OnG59() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "G59", m_bG59 );
}

void CAddWorkOffsetDlg::OnGenerateM05() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "User", "M05", m_bGenerateM05 );
}


